#include<stdio.h>
#include<stdlib.h>
#include<sys/types.h>
#include<unistd.h>
#include<pthread.h>
#include"errno.h"
#include"mpi.h"


int
_USF_num_bits (int n)
{
  int i = 0;

  if (n == 0)
    return 1;
  for (; n > 0; i++) {
    n >>= 1;

  }
  return i;
}

int
_USF_make_bm (int n)
{
  int i, rv = 1;
  for (i = 1; i < n; i++) {
    rv <<= 1;
  }
  return rv;

}

// tag -10 is used for barrier.
int
MPI_Barrier (MPI_Comm comm)
{
  int nump, rank, my_rank, mes;
  int bm, nb, cb;
  int partner, cont;
  MPI_Status status;

  MPI_Comm_size (comm, &nump);
  MPI_Comm_rank (comm, &rank);
  my_rank = rank;

  if (rank == -1) {
    printf ("Wrong communicator in calling MPI_Barrier\n");
    fflush (stdout);
    return 1;
  }

  nb = _USF_num_bits (nump - 1);
  bm = _USF_make_bm (nb);

  cb = bm;
  while (cb != 0) {
    partner = rank ^ cb;
    cb >>= 1;
    if (rank < partner) {
      if (partner >= nump) {
        continue;
      }
      MPI_Recv (&mes, 1, MPI_INT, partner, -10, comm, &status);
    } else {
      MPI_Send (&mes, 1, MPI_INT, partner, -10, comm);
      break;
    }
  }

  // May just use Bcast instead, to get rid of code duplication
  cb = 1;
  while (cb <= bm) {
    partner = rank ^ cb;
    cb <<= 1;
    fflush (stdout);
    if (_USF_num_bits (rank) > cb) {
      continue;
    }
    if (rank > partner) {
      MPI_Recv (&mes, 1, MPI_INT, partner, -10, comm, &status);
    } else {
      if (partner >= nump) {
        continue;
      }
      MPI_Send (&mes, 1, MPI_INT, partner, -10, comm);
    }
  }

  return 0;
}
