#include<stdio.h>
#include<stdlib.h>
#include<sys/types.h>
#include<unistd.h>
#include<pthread.h>
#include"errno.h"
#include"mpi.h"

// tag -11 is used for bcast.
int
MPI_Bcast (void *buffer, int count, MPI_Datatype datatype,
           int root, MPI_Comm comm)
{
  int nump, rank, mes, my_rank, i;
  int bm, nb, cb;
  int partner, cont;
  MPI_Status status;
  int orrank;

  MPI_Comm_size (comm, &nump);
  MPI_Comm_rank (comm, &rank);

  if (rank == -1) {
    printf ("Wrong communicator in calling MPI_Bcast\n");
    fflush (stdout);
    return 1;
  }

  my_rank = rank;
  nb = _USF_num_bits (nump - 1);
  bm = _USF_make_bm (nb);

  cb = 1;
  orrank = rank;
  if (rank == 0)
    rank = root;
  else if (rank == root)
    rank = 0;

  while (cb <= bm) {
    partner = rank ^ cb;
    cb <<= 1;

    if (_USF_num_bits (rank) > cb)
      continue;
    if (rank > partner) {
      if (partner == 0)
        partner = root;
      else if (partner == root)
        partner = 0;
      MPI_Recv (buffer, count, datatype, partner, -11, comm, &status);
    } else {
      if (partner == 0)
        partner = root;
      else if (partner == root)
        partner = 0;
      if (partner >= nump)
        continue;
      MPI_Send (buffer, count, datatype, partner, -11, comm);
    }
  }

  return 0;
}
