#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <errno.h>
#include <string.h>
#include <netdb.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <sys/wait.h>
#include <signal.h>
#include <pthread.h>
#include "mpi.h"

pool_t *_USF_mpi_request_int_pool;
pool_t *_USF_request_node_pool;
pool_t *_USF_sysreq_node_pool;

int
MPI_Init (int *argc, char ***argv)
{
  _USF_mpi_request_int_pool =
    pool_fill (16, -1, 8, -1, sizeof (MPI_Request_Int), (pool_malloc) malloc,
               (pool_free) free, NULL, NULL);
  _USF_request_node_pool =
    pool_fill (16, -1, 8, -1, sizeof (_USF_request_node),
               (pool_malloc) malloc, (pool_free) free, NULL, NULL);
  _USF_sysreq_node_pool =
    pool_fill (16, -1, 8, -1, sizeof (_USF_sysreq_node), (pool_malloc) malloc,
               (pool_free) free, NULL, NULL);

#ifdef _USF_MPI_TCP_

  _USF_TCP_init (argc, argv);
  _USF_TCP_thread_init ();
#endif

#ifdef _USF_MPI_GM_

  _USF_GM_init (argc, argv);
  _USF_GM_thread_init ();

#endif

  return 0;
}
