#include<stdio.h>
#include<stdlib.h>
#include"mpi.h"

int
MPI_Iprobe (int source, int tag, MPI_Comm comm,
            int *flag, MPI_Status * status)
{
  int rank;                     /* The rank of the current processor. */
  _USF_sysreq_node *sreq;

  MPI_Comm_rank (comm, &rank);

#ifdef DEBUG
  printf ("rank %d iProbe start\n", rank);
  fflush (stdout);
#endif
  sreq = _USF_sysreq_lookup (tag, source, _USF_SEND, comm);
  if (sreq == NULL) {
    *flag = 0;
  } else {
    *flag = 1;
    status->count = sreq->size;
    status->MPI_SOURCE = sreq->source;
    status->MPI_TAG = sreq->tag;
  }
#ifdef DEBUG
  printf ("rank %d iProbe end\n", rank);
  fflush (stdout);
#endif

  return 0;
}
