#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include"mpi.h"

int
MPI_Sendrecv_replace (void *buf, int count, MPI_Datatype datatype,
                      int dest, int sendtag, int source, int recvtag,
                      MPI_Comm comm, MPI_Status * status)
{
  MPI_Request reqs[2];
  MPI_Status st;
  void *tmpbuf;
  int size;

  size = _USF_mpi_sizeof (datatype) * count;
  tmpbuf = malloc (size);
  memcpy (tmpbuf, buf, size);
  MPI_Isend (tmpbuf, count, datatype, dest, sendtag, comm, &reqs[0]);
  MPI_Irecv (buf, count, datatype, source, recvtag, comm, &reqs[1]);
  MPI_Wait (&reqs[0], &st);
  MPI_Wait (&reqs[1], status);
  free (tmpbuf);
  return 0;
}
