#include<stdio.h>
#include<stdlib.h>
#include<unistd.h>
#include<time.h>
#include"mpi.h"

int
MPI_Waitany (int count, MPI_Request * array_of_requests, int *index,
             MPI_Status * status)
{
  const struct timespec t1 = { 0, 500000 };
  struct timespec t2;
  int i;

  while (1) {
    for (i = 0; i < count; i++) {
      pthread_mutex_lock (&_USF_mut_req);
      status->count = 0;
      if (array_of_requests[i] == MPI_REQUEST_NULL) {
        pthread_mutex_unlock (&_USF_mut_req);
        continue;
      }
      if (!(array_of_requests[i]->active)) {
        pthread_mutex_unlock (&_USF_mut_req);
        continue;
      }
      if (array_of_requests[i]->done) {
        *index = i;
        status->count = array_of_requests[i]->size;
        status->MPI_SOURCE = array_of_requests[i]->peer;
        status->MPI_TAG = array_of_requests[i]->tag;
        _USF_request_remove (array_of_requests[i]->node);
        array_of_requests[i] = MPI_REQUEST_NULL;
        pthread_mutex_unlock (&_USF_mut_req);
        return 0;
      }
      pthread_mutex_unlock (&_USF_mut_req);
    }
    nanosleep (&t1, &t2);
  }
  return 0;
}
